#include <bits/stdc++.h>

using namespace std;
#define int long long

vector <int> pref;
int sum (int l,int r) {
  r++;
  return pref[r] - pref[l];
}

vector <int> tree;

void update (int i,int l,int r,int pos,int val) {
  if (pos + 1 <= l || r <= pos){
    return ;
  }
  if (r - l == 1) {
    tree[i] = val;
    return ;
  }
  int m = (l + r) / 2;
  update(2 * i + 1,l,m,pos,val);
  update(2 * i + 2,m,r,pos,val);
  tree[i] = tree[2 * i + 1] + tree[2 * i + 2];
}

int find_id (int i,int l,int r,int k) {
  if (r - l == 1) {
    return l;
  }
  int m = (l + r) / 2;
  if (tree[2 * i + 1] >= k) {
    return find_id(2 * i + 1,l,m,k);
  }
  return find_id(2 * i + 2,m,r,k - tree[2 * i + 1]);
}

void init (int i,int l,int r) {
  if (r - l == 1) {
    tree[i] = 1;
    return ;
  }
  int m = (l + r) / 2;
  init(2 * i + 1,l,m);
  init(2 * i + 2,m,r);
  tree[i] = tree[2 * i + 1] + tree[2 * i + 2];
}
vector < set <int> > cnt;
vector <int> h;
int get (int l1,int r1) {
  r1--;
  l1++;
  if (l1 <= r1)
    return max(min(h[l1 - 1],h[r1 + 1]) * (r1 - l1 + 1) - sum (l1,r1),0LL);
  return 0;
}
void ADD (int id,int x,int &lc) {
  if (cnt[id].count(x)) {
    return ;
  }
  if (cnt[id].empty()) {
    cnt[id].insert(x);
    return ;
  }
  if (x < *cnt[id].begin()) {
    lc += get(x,*cnt[id].begin());
    cnt[id].insert(x);
    return ;
  }
  if (x > *--cnt[id].end()) {
    lc += get(*--cnt[id].end(),x);
    cnt[id].insert(x);
    return ;
  }
  auto it = cnt[id].upper_bound(x);
  int l = *it;
  int r = *--it;
  lc -= get(l,r);
  lc += get(l,x);
  lc += get(x,r);
  cnt[id].insert(x);
}

void DEL (int id,int x,int &lc) {
  if (!cnt[id].count(x)) {
    return ;
  }
  if (cnt[id].size() == 1) {
    cnt[id].erase(x);
    return ;
  }
  if (x == *cnt[id].begin()) {
    lc -= get(x,*++cnt[id].begin());
    cnt[id].erase(x);
    return ;
  }
  if (x == *--cnt[id].end()) {
    lc -= get(*--cnt[id].end(),x);
    cnt[id].erase(x);
    return ;
  }
  auto it = cnt[id].lower_bound(x);
  int l = *it;
  int r = *--it;
  lc += get(l,r);
  lc -= get(l,x);
  lc -= get(x,r);
  cnt[id].erase(x);
}


signed main () {
  freopen("test.txt","r",stdin);
  int n;
  cin >> n;
  h = vector <int> (n);
  for (int i = 0;i < n;i++) {
    cin >> h[i];
  }
  pref = vector <int> (n + 1,0);
  pref[0] = 0;
  for (int i = 1;i <= n;i++) {
    pref[i] += pref[i - 1] + h[i - 1];
  }
  vector <int> ans(n,0);
  vector < list < int > > st1(n);
  vector < list < int > > st2(n);
  cnt = vector < set <int> > (n);
  tree = vector <int> (4 * n);
  init(0,0,n);
  for (int i = 0;i < n;i++) {
    st1[i].push_back(i);
    st2[i].push_back(i);
    ADD(i,i,ans[i]);
  }
  //cout << "good";
  for (int _ = 0;_ < n - 1;_++) {
    int k;
    cin >> k;
    int i1 = find_id(0,0,n,k);
    int i2 = find_id(0,0,n,k + 1);
    while (!st1[i2].empty() && !st1[i1].empty() && h[st1[i1].back()] < h[st1[i2].front()]) {
      DEL(i1,st1[i1].back(),ans[i1]);
      st1[i1].pop_back();
    }
    while (!st2[i2].empty() && !st2[i1].empty() && h[st2[i1].back()] > h[st2[i2].front()]) {
      DEL(i2,st2[i2].front(),ans[i2]);
      st2[i2].pop_front();
    }
    update(0,0,n,i2,0);
    for (auto x: st1[i2]) {
      st1[i1].push_back(x);
      ADD(i1,x,ans[i1]);
    }
    for (auto x: st2[i2]) {
      st2[i1].push_back(x);
      ADD(i1,x,ans[i1]);
    }
    for (auto x: cnt[i2]) {
      ADD(i1,x,ans[i1]);
    }
    ans[i2] = 0;
    cout << ans[i1] << endl;
  }
  return 0;
}
