#include <bits/stdc++.h>

using namespace std;
#define int long long

vector <int> pref;
int sum (int l,int r) {
  r++;
  return pref[r] - pref[l];
}

vector <int> tree;

void update (int i,int l,int r,int pos,int val) {
  if (pos + 1 <= l || r <= pos){
    return ;
  }
  if (r - l == 1) {
    tree[i] = val;
    return ;
  }
  int m = (l + r) / 2;
  update(2 * i + 1,l,m,pos,val);
  update(2 * i + 2,m,r,pos,val);
  tree[i] = tree[2 * i + 1] + tree[2 * i + 2];
}

int find_id (int i,int l,int r,int k) {
  if (r - l == 1) {
    return l;
  }
  int m = (l + r) / 2;
  if (tree[2 * i + 1] >= k) {
    return find_id(2 * i + 1,l,m,k);
  }
  return find_id(2 * i + 2,m,r,k - tree[2 * i + 1]);
}

void init (int i,int l,int r) {
  if (r - l == 1) {
    tree[i] = 1;
    return ;
  }
  int m = (l + r) / 2;
  init(2 * i + 1,l,m);
  init(2 * i + 2,m,r);
  tree[i] = tree[2 * i + 1] + tree[2 * i + 2];
}
signed main () {
  int n;
  cin >> n;
  vector <int> h(n);
  for (int i = 0;i < n;i++) {
    cin >> h[i];
  }
  pref = vector <int> (n + 1,0);
  pref[0] = 0;
  for (int i = 1;i <= n;i++) {
    pref[i] += pref[i - 1] + h[i - 1];
  }
  tree = vector <int> (4 * n);
  init(0,0,n);
  vector <int> ans(n,0);
  vector < vector < int > > st(n);
  for (int i = 0;i < n;i++) {
    st[i].push_back(i);
  }
  //cout << "good";
  for (int _ = 0;_ < n - 1;_++) {
    int k;
    cin >> k;
    int i1 = find_id(0,0,n,k);
    int i2 = find_id(0,0,n,k + 1);
    ans[i1] = 0;
    ans[i2] = 0;
    for (auto x: st[i2]) {
      st[i1].push_back(x);
    }
    st[i2].clear();
    update(0,0,n,i2,0);
    int lmx = 0;
    int rmx = 0;
    vector <int> mn(st[i1].size(),1e18);
    for (int i = 0;i < st[i1].size();i++) {
      lmx = max(lmx,h[st[i1][i]]);
      mn[i] = min(lmx,mn[i]);
    }
    for (int i = st[i1].size() - 1;i >= 0;i--) {
      rmx = max(rmx,h[st[i1][i]]);
      mn[i] = min(rmx,mn[i]);
    }
    for (int i = 0;i < st[i1].size();i++) {
      ans[i1] += mn[i] - h[st[i1][i]];
    }
    cout << ans[i1] << endl;
  }
  return 0;
}
