#include <bits/stdc++.h>

using namespace std;
#define int long long

vector <int> pref;
int sum (int l,int r) {
  r++;
  return pref[r] - pref[l];
}

vector <int> tree;

void update (int i,int l,int r,int pos,int val) {
  if (pos + 1 <= l || r <= pos){
    return ;
  }
  if (r - l == 1) {
    tree[i] = val;
    return ;
  }
  int m = (l + r) / 2;
  update(2 * i + 1,l,m,pos,val);
  update(2 * i + 2,m,r,pos,val);
  tree[i] = tree[2 * i + 1] + tree[2 * i + 2];
}

int find_id (int i,int l,int r,int k) {
  if (r - l == 1) {
    return l;
  }
  int m = (l + r) / 2;
  if (tree[2 * i + 1] >= k) {
    return find_id(2 * i + 1,l,m,k);
  }
  return find_id(2 * i + 2,m,r,k - tree[2 * i + 1]);
}

void init (int i,int l,int r) {
  if (r - l == 1) {
    tree[i] = 1;
    return ;
  }
  int m = (l + r) / 2;
  init(2 * i + 1,l,m);
  init(2 * i + 2,m,r);
  tree[i] = tree[2 * i + 1] + tree[2 * i + 2];
}
signed main () {
  //freopen("test.txt","r",stdin);
  int n;
  cin >> n;
  vector <int> h(n);
  for (int i = 0;i < n;i++) {
    cin >> h[i];
  }
  pref = vector <int> (n + 1,0);
  pref[0] = 0;
  for (int i = 1;i <= n;i++) {
    pref[i] += pref[i - 1] + h[i - 1];
  }
  vector <int> ans(n,0);
  vector < list < int > > st(n);
  tree = vector <int> (4 * n);
  init(0,0,n);
  for (int i = 0;i < n;i++) {
    st[i].push_back(i);
  }
  //cout << "good";
  for (int _ = 0;_ < n - 1;_++) {
    int k;
    cin >> k;
    int i1 = find_id(0,0,n,k);
    int i2 = find_id(0,0,n,k + 1);
    int lc = ans[i1] + ans[i2];
    ans[i1] = 0;
    ans[i2] = 0;
    {
      while (1) {
        int c = 0;
        while (st[i1].size() >= 2) {
          int ih2 = st[i1].back();
          st[i1].pop_back();
          int ih1 = st[i1].back();
          int ih3 = st[i2].front();
          if (h[ih1] > h[ih2] && h[ih2] < h[ih3]) {
            c++;
            int r1 = ih2;
            int l1 = ih1;
            r1--;
            l1++;
            if (l1 <= r1)
              lc += max(min(h[l1 - 1],h[r1 + 1]) * (r1 - l1 + 1) - sum (l1,r1),0LL);
            continue;
          } else {
            st[i1].push_back(ih2);
            break;
          }
        }
        while (st[i2].size() >= 2) {
          int ih2 = st[i2].front();
          st[i2].pop_front();
          int ih3 = st[i2].front();
          int ih1 = st[i1].back();
          if (h[ih1] > h[ih2] && h[ih2] < h[ih3]) {
            c++;
            c++;
            int r1 = ih3;
            int l1 = ih2;
            r1--;
            l1++;
            if (l1 <= r1)
              lc += max(min(h[l1 - 1],h[r1 + 1]) * (r1 - l1 + 1) - sum (l1,r1),0LL);
            continue;
          } else {
            st[i2].push_front(ih2);
            break;
          }
        }
        if (c == 0) {
          break;
        }
      }
      if (!st[i1].empty()){
        int r1 = st[i2].front();
        int l1 = st[i1].back();
        r1--;
        l1++;
        if (l1 <= r1)
          lc += max(min(h[l1 - 1],h[r1 + 1]) * (r1 - l1 + 1) - sum (l1,r1),0LL);
      }
    }
    for (auto x: st[i2]) {
      st[i1].push_back(x);
    }
    st[i2].clear();
    update(0,0,n,i2,0);
    ans[i1] = lc;
    cout << ans[i1] << endl;
  }
  return 0;
}
